import sys
import libvirt
import time
import spawnvm

# domName = 'server1'

conn = libvirt.open('qemu:///system')
if conn == None:
    print('Failed to open connection to qemu:///system', file=sys.stderr)
    exit(1)

doms = conn.listAllDomains()
active_doms = conn.listAllDomains(1)
inactive_doms = conn.listAllDomains(2)
# print(inactive_doms[0].name())

if(len(active_doms) == 0):
	doms[0].create()
	active_doms = conn.listAllDomains(1)


# dom = conn.lookupByName('server2')
# if dom == None:
#     print('Failed to find the domain '+domName, file=sys.stderr)
#     exit(1)

THRESHOLD = 20

dom = active_doms[0]

cpu_time = {}
curr_cpu_time = {}
count_up = {}
count_down = {}

for dom in active_doms:
	state = dom.getCPUStats(True)
	dom_name = dom.name()
	cpu_time[dom_name] = state[0]['cpu_time'] / 1000000.
	count_up[dom_name] = 0
	count_down[dom_name] = 0


# cpu_stats = dom.getCPUStats(True)
# cpu_time = cpu_stats[0]['cpu_time']/1000000.


while True:
	active_doms = conn.listAllDomains(1)
	inactive_doms = conn.listAllDomains(2)

	for dom in inactive_doms:
		try:
			del count_up[dom.name()]
		except:
			pass
		try:
			del count_down[dom.name()]
		except:
			pass
		try:
			del cpu_time[dom.name()]
		except:
			pass

	for dom in active_doms:
		state = dom.getCPUStats(True)
		dom_name = dom.name()
		curr_cpu_time = state[0]['cpu_time'] / 1000000.

		if dom_name not in cpu_time.keys():
			cpu_time[dom_name] = curr_cpu_time

		if dom_name not in count_up.keys():
			count_up[dom_name] = 0

		if dom_name not in count_down.keys():
			count_down[dom_name] = 0

		if ((curr_cpu_time - cpu_time[dom_name]) > 100):
			if(count_up[dom_name] <= THRESHOLD):
				count_up[dom_name] = count_up[dom_name] + 1
				print (dom_name + " count_up : " + str(count_up[dom_name]))
		else :
			count_up[dom_name] = 0

		if (count_up[dom_name] == THRESHOLD):
			print ("spawning vm")
			spawnvm.spawn(conn)
		elif((curr_cpu_time - cpu_time[dom_name]) < 50):
			if(count_down[dom_name] <= THRESHOLD):
				count_down[dom_name] = count_down[dom_name] + 1
				print (dom_name + " count_down : " + str(count_down[dom_name]))
		else:
			count_down[dom_name] = 0

		if (count_down[dom_name] == THRESHOLD):
			if(len(active_doms) > 1):
				spawnvm.shutdown(conn,dom)



		cpu_time[dom_name] = curr_cpu_time



	# cpu_stats = dom.getCPUStats(True)
	# for (i, cpu) in enumerate(cpu_stats):
	# 	curr_cpu_time = cpu['cpu_time'] / 1000000.
	# 	print('CPU '+str(i)+' Time Diff: '+str(curr_cpu_time - cpu_time))

		
	time.sleep(1)

conn.close()
exit(0)